#include "AD7706.h"

/************************************************************************
*                                                                       *
************************************************************************/
void Init_SPI_8535(void)
{
unsigned int	q;

	PORTB = (1 << PORTB7);							// Set SCK high
	DDRB = ((1 << PINB7) | (1 << PINB5));					// Set SCK and MOSI as output

 SPCR = ((1<<SPE) | (1<<MSTR) | (1<<CPHA) | (1<<CPOL) | (1<<SPR1) | (1<<SPR0));	//Enable SPI in Master mode, mode 3, 
 SPSR &= ~(1<<SPI2X);								// rate f/128

	PORTB &= ~(1 << PORTB5);						// MOSI
	__delay_cycles(1000);
	PORTB |= (1 << PORTB5);

q = SPSR;
q = SPDR;				// read for clean SPSR, SPDR

}
/************************************************************************
*                                                                       *
************************************************************************/
void Init_AD7706(void)
{
	PORTB= (1 << PORTB3);			// Set CS_AD7706
	DDRB = (1 << PINB3);			// Set CS_AD7706

	PORTD= (1 << PORTD3);			// Set RESET_AD7706 high
	DDRD = (1 << PIND3);			// Set RESET_AD7706 as output

RESET_AD7706 = 1;

WR_AD7706(0x20);		// next write for CLOCK r-r (AIN1)
WR_AD7706(0x04);		// CLOCK r-r: --> CLK=1: 2,4576 MHz, 50 Hz
WR_AD7706(0x10);		// next write for SETUP r-r
WR_AD7706(0x6C);		// SETUP r-r: --> self-calibration, gain=32,
				//                unipolar, buffer off, FSYNC=0
while(RDY_AD7706);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);

);
WR_AD7706(unsigned char byte)
{
unsigned int	q;

q = SPSR;
q = SPDR;				// clean

CS_AD7706 = 0;

SPDR = byte;				// write byte to SPI

while(!(SPSR & 0x80));

CS_AD7706 = 1;
}
/************************************************************************
*                                                                       *
*************************************************************************
*     Input:   number channel (0 - 2)                                   *
*     Output:  16-bit data                                              *
*----------------------------------------------------------------------*/
unsigned int RD_AD7706(unsigned char n_chan)
{
unsigned int	temp;

while(RDY_AD7706);

WR_AD7706(0x38 | n_chan);		// read from DATA r-r

WR_AD7706(0x00);			// put byte 'dummy' in SPI data register
	temp = (unsigned) SPDR<<8;		//read value in SPI data reg. (high)
WR_AD7706(0x00);			// put byte 'dummy' in SPI data register
	temp |= SPDR;				//read value in SPI data reg. (low)

	return temp;
}
